#{extends 'borderNG.html' /}
#{set 'titleHead'}
Rincian HPS
#{/set}

<ol class="breadcrumb">
    <li><a href="@{BerandaCtr.index()}">Beranda</a></li>
#{if swakelola.lls_status.draft}
    <li><a href="@{swakelola.PaketSwakelolaCtr.index()}">Daftar Paket </a></li>
    <li><a href="@{swakelola.SwakelolaCtr.edit(swakelola.lls_id)}">Edit Swakelola</a></li>
#{/if}
#{else}
    <li><a href="@{nonlelang.PengadaanLCtr.view(swakelola.lls_id)}">Informasi PL</a></li>
#{/else}
    <li class="active">Rincian HPS</li>
</ol>
<div class="content">
    <div id="alert"></div>
#{if editable}
    <table id="template" class="table table-sm">
        <tr>
            <th><a class="btn btn-secondary " href="#" onclick="$('#rincian_upload').click()" id="uploadHPS">Upload
                Rincian HPS</a>
                <a href="#{assets '/documents/template-rincian.xlsx'/}" class="btn btn-secondary "><i class="fa fa-download"></i> Template Rincian
                    HPS</a></th>
            <th><input type="file" id="rincian_upload" class="form-control" style="display:none"
                       placeholder="Upload Rincian HPS" #{if !editable} disabled #{/if}></th>
        </tr>
    </table>
#{/if}

    <div class="bs-callout bs-callout-info">
        <b>Petunjuk pengisian rincian HPS menggunakan template Excel :</b><br/>
        1. Jangan merubah nama kolom.<br/>
        2. Jangan merubah nama sheet.<br/>
    </div>

    <div class="clearfix"></div>
*{<div class="bs-callout bs-callout-info">
        Untuk menambah baris baru, klik kanan pada tabel di bawah.
    </div>}*
    <div id="tbl-rincian" style="margin:20px;"></div>
    <div class="float-right">
        <table id="rekap" class="table table-sm" style="width:300px;margin-right:50px;">
            <tr>
                <th style="text-align:right">TOTAL NILAI</th>
                <th id="total_hps" style="text-align:right"></th>
            </tr>
        </table>
    </div>
    <div class="clearfix"></div>
#{if editable}
    #{authenticityToken /}
    <button type="button" name="simpan" id="simpan" class="btn btn-success"><i class="fa fa-save"></i> Simpan</button>
#{/if}
#{backButton action:@swakelola.SwakelolaCtr.edit(swakelola.lls_id) /}
</div>

#{set 'css_custom' }
    #{if editable}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/css/jquery.fileupload.min.css" rel="stylesheet" type="text/css">
    #{/if}
<link href="#{assets '/handsontable/handsontable.full.min.css'/}" rel="stylesheet" type="text/css">
#{/set}


#{set 'custom_script'}
    #{if editable}
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/vendor/jquery.ui.widget.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.iframe-transport.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-process.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-validate.min.js"></script>
    #{/if}
<script type="text/javascript" src="#{assets '/handsontable/handsontable.full.min.js'/}"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/PapaParse/5.1.0/papaparse.min.js"></script>

<script type="text/javascript" src="https://unpkg.com/xlsx@0.15.6/dist/jszip.js"></script>
<script type="text/javascript" src="https://unpkg.com/xlsx@0.15.6/dist/xlsx.min.js"></script>>

<script type="text/javascript">

    var data = ${data?.raw()};
    var interval = 2 * 60 * 1000; // 2 menit
    var total = 0;
    var fixed = true;

    var X = XLSX;

    $(document).on('change', '#rincian_upload', function (e) {
        var files = e.target.files;
        var f = files[0];
        {
            var reader = new FileReader();
            var name = f.name;
            reader.onload = function (e) {
                var data = e.target.result;
                try {
                    var wb = X.read(data, {type: 'binary'});
                    process_wb(wb);
                }catch(err){
                    console.log(err);
                    alert("Format file HPS yang Anda upload tidak valid.");
                }
            };
            reader.readAsBinaryString(f);
        }
    });

    function process_wb(wb) {
        var output = to_json(wb);
        var res = output['rincian-hps'];
        var obj = new Array();
        for (i = 0; i < res.length; i++) {
            var totalharga = 0;
            var totalpajak = 0;

            var item = replaceChar(res[i]['Jenis Barang/Jasa']);
            var unit = replaceChar(res[i]['Satuan']);
            var vol = res[i]['Vol'];
            // var unit2 = replaceChar(res[i]['Satuan 2']);
            // var vol2 = res[i]['Vol 2'];
            var harga = res[i]['Harga'];
            var pajak = res[i]['Pajak(%)'];
            //var total_harga = totalharga;
            var keterangan = replaceChar(res[i]['Keterangan']);

            if (!parseInt(harga, 10)) {
                harga = 0;
            }

            if (!parseInt(vol, 10)) {
                vol = 0;
            } else {
                totalharga = vol * harga;
            }

            // if (!parseInt(vol2, 10)) {
            //     //console.log("vol2 not null");
            //     vol2 = 1;
            // }
            // if (vol2 > 0) {
            //     //console.log("if 2 :"+parseInt(res[i][2], 10))
            //     totalharga = vol * vol2 * harga;
            // }

            //pajak ga boleh null
            if (!parseInt(pajak, 10)) {
                totalpajak = 0;
            }
            if (pajak > 0) {
                totalpajak = (pajak / 100) * totalharga;
                totalharga += totalpajak;
            }

            obj.push({
                item: item,
                unit: unit,
                vol: vol,
                unit2: unit2,
                vol2: vol2,
                harga: harga,
                pajak: pajak,
                //asep:total to auto
                //total_harga:res[i][7],
                total_harga: totalharga,
                keterangan: keterangan
            })

        }
        data = obj;
        $("#tbl-rincian").handsontable("loadData", obj);
        summary();
    }

    function to_json(workbook) {
        var result = {};
        workbook.SheetNames.forEach(function (sheetName) {
            var roa = X.utils.sheet_to_row_object_array(workbook.Sheets[sheetName]);
            if (roa.length > 0) {
                result[sheetName] = roa;
            }
        });
        return result;
    }

    function replaceChar(str) {
        var strs = "";
        if(str != undefined)
            strs += str;

        return strs.replace(/[^a-zA-Z0-9.,!@#$%&@*()-+=/\-\s ]/g, "");
    }
    function summary() {
        var data = $("#tbl-rincian").data('handsontable').getData();
        var total_hps = 0;
        var total = 0;
        for (i = 0; i < data.length; i++) {
            if (data[i].total_harga)
                total += parseFloat(data[i].total_harga);
        }
	    if (total > 0) {
		    total_hps = parseFloat(total);
	    }
	    $("#rekap").find("#total_hps").text(toRupiah(rounded2Decimal(total_hps)));
    }

    if (data.length == 0) {
        data.push({
            item: "",
            unit: "",
            vol: 1,
            unit2: "",
            vol2: 1,
            harga: 0,
            pajak: 10,
            total_harga: 0,
            keterangan: ""
        });
    }

    $("#tbl-rincian").handsontable({
        rowHeaders: true,
        dataSchema: {
            item: "",
            unit: "",
            vol: 1,
            unit2: "",
            vol2: 1,
            harga: 0,
            pajak: 10,
            total_harga: 0,
            keterangan: ""
        },
        data: data,
        #{if editable}
            contextMenu: {
                items: {
                    "row_above": {name: "Tambah Baris Diatas"},
                    "row_below": {name: "Tambah Baris Dibawah"},
                    "remove_row": {name: "Hapus Baris"},
                    "undo": {name: "Undo"},
                    "redo": {name: "Redo"}
                }
            },
        #{/if}
        columns: [{data: 'item', width: 200, title: 'Jenis Barang/Jasa'},
            {data: 'unit', width: 100, title: 'Satuan'},
            {data: 'vol', type: 'numeric', format: '0,0.00', width: 50, title: 'Vol'},
            // {data: 'unit2', width: 100, title: 'Satuan 2'},
            // {data: 'vol2', type: 'numeric', format: '0,0.00', width: 50, title: 'Vol 2'},
            {data: 'harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Harga'},
            {data: 'pajak', type: 'numeric', format: '0,0.00', width: 60, title: 'Pajak (%)', dataSchema: 10},
            {data: 'total_harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Total'},
            {data: 'keterangan', width: 250, title: 'Keterangan'}],


        cells: function (row, col, prop) {

            var cellProperties = {};
            #{if editable}
                if (col == 5) {
                    cellProperties.readOnly = true;
                }
                if (data[row] && (col == 2 || col == 3 || col == 4)) {
                    var total = 0;
                    if (data[row].vol <= 0)
                        data[row].vol = 1.0;

                    // if (row == 0)
                    //console.log(data[row])
                    if (data[row].harga > 0)
                        total = data[row].harga;
                    if (data[row].vol > 0) {
                        data[row].vol = rounded2Decimal(parseFloat(data[row].vol));
                        total = total * data[row].vol;
                    }
                    if (data[row].pajak > 0)
                        total = total + ((total * data[row].pajak) / 100);
                    else
                        data[row].pajak = 0;
                    if (total > 0) {
                        data[row].total_harga = rounded2Decimal(total);

                    }
                }
                if (data[row] && (col == 1 || col == 2 || col == 6)) {
                    data[row].item = replaceChar(data[row].item);
                    data[row].unit = replaceChar(data[row].unit);
                    data[row].keterangan = replaceChar(data[row].keterangan);
                }
            #{/if}
            #{else}
                cellProperties.readOnly = true;
            #{/else}
            return cellProperties;
        },
        afterChange: function (change, source) {
            console.log('after change')
            summary();
        },
        afterRemoveRow: function () {
            console.log('after remove row')
            summary();
        },
    });
    $("#fixed").on('change', function () {
        fixed = this.checked ? false : true;
    });
        #{if editable}
        $("#simpan").click(function () {
            autosave();
        });
        function autosave() {
            var postdata = $("#tbl-rincian").data('handsontable').getData();
            var token = $("input[name='authenticityToken']").val();
            $.ajax({
                url: '@{swakelola.DokumenSwakelolaCtr.hpsSubmit(swakelola.lls_id)}',
                data: {"data": JSON.stringify(postdata), "fixed": fixed, "authenticityToken": token},
                type: 'POST',
                success: function (res) {
                    if (res.result === 'ok')
                        $('#alert').html('<div class="alert alert-success">Data berhasil tersimpan</div>');
                    else if (res.result.length > 0)
                        $('#alert').html('<div class="alert alert-danger">' + res.result + '</div>');
                    else
                        $('#alert').html('<div class="alert alert-danger">Data gagal tersimpan, mohon periksa kembali inputan Anda</div>');
                },
                error: function () {
                    $('#alert').html('<div class="alert alert-danger">Data gagal tersimpan karena ada kendala jaringan/server</div>');
                }
            });
        }
        setInterval(autosave, interval);
        #{/if}
</script>
#{/set}